<script setup>
import { ref } from 'vue';
import { useStore } from 'vuex';
import router from '../router';


const store = useStore()
const emit = defineEmits(["onAuthSuccess"]) // Do we need this anymore ??

// Local states
const username = ref("")
const displayError = ref("")
const displaySuccess = ref("")


const onCheckUser = async (action) => {

    const error = await store.dispatch("saveUsername", {
        action,
        username
    })

if (error !== null) {
    displayError.value = error
} else {
    displaySuccess.value // not tested because onCheckUser is broken ---- !!! ----
    }
}

const onStartTrivia = () => {
    router.push("/questions")
}
</script>


<template>
    <main class="container mx-auto px-4">
        <h1 class="mb-3 text-6xl">Trivia Game</h1>

        <form class="mb-3">
            <fieldset class="mb-3">
                <label for="username" aria-label="Username" class="block">Username</label>
                <input
                    type="text"
                    id="username"
                    placeholder="John Doe"
                    class="border border-slate-500"
                    v-model.trim="username"
                />

                <button @click="onCheckUser('getUser')" type="button" class="bg-slate-600 text-white p-2 rounded mb-3">Get user</button>

            </fieldset>

            <p class="mt-10 mb-3 text-4xl underline">Game Settings</p>

            <fieldset class="mb-3">
                <label class="block mb-3 text-xl">Difficulty :</label>
                <label class="block mb-3 text-lg">Any</label>
            </fieldset>

            <fieldset class="mb-3">
                <label class="block mb-3 text-xl">Number of Questions :</label>
                <label class="block mb-3 text-lg">10</label>
            </fieldset>

                <fieldset class="mb-3">
                    <label class="block mb-3 text-xl">Category :</label>
                    <label class="block mb-3 text-lg">Any</label>
                </fieldset>

            <fieldset class="mb-3">
                <label class="block mb-3 text-xl">Type of Questions :</label>
                <label class="block mb-3 text-lg">True/False and Multiple choice</label>
            </fieldset>

            <button @click="onStartTrivia" type="button" class="bg-slate-600 text-white p-2 rounded mb-3 mt-4">Start Trivia Game</button>

        </form>

        <div v-if="displayError" class="mb-3 bg-red-500 text-white p-2">
            <span class="block text-lg mb-3">Error</span>
            <p>{{ displayError }}</p>
        </div>

        <div v-if="displaySuccess" class="mb-3 bg-green-500 text-white p-2">
            <span class="block text-lg mb-3">Success</span>
            <p>{{ displaySuccess }}</p>
        </div>

    </main>
</template>
